#include <iostream>
using namespace std;

struct Node {
	// Layer-3 (char) linked list
	int x;		// Screen X pos for OCR char
	int y; 		// Screen Y pos for OCR char
	int ascii;	// ASCII value of OCR char
	int bit;	// Binary digit value of OCR chars 48|49 (0|1)
	int tgxf_char;	// Set if valid TGXf Layer-3 char
	int tgxf_row;	// Set if exactly 16 TGXf chars (bits) are in this Y pos
	// Layer-4 (TGXf) linked list
	int counter;	// TGXf Counter value
	int octet;	// TGXf Octet value
	// Both
	Node *next;	// link
};

class LinkedList {
	public:
		LinkedList(void);
		Node * add_char(int x, int y, int a);
		Node * get_next(Node * n);
		Node * del_char(Node * n);
		void empty_list(void);
		int get_nearest_y(int y);
		int get_nearest_x_for_y(int x, int y, int binary);
		int mark_row(int y);
		int mark_tgxf_rows(void);
		Node * get_next_tgxf_char(Node * n);
		Node * append_tgxf_octet(int c, int o);
		int populate_tgxf_list(LinkedList& tgxf_list);
		Node * pop_tgxf_octet(void);
	private:
		Node *head;
};

